PROGRAM bresenline;

CONST (*$I TRIXCONS.PAS*)
TYPE  (*$I TRIXTYPE.PAS*)

(*$I TRIXSUBS.PAS*)
(*$I C:\PASCAL\BIBLIOTH\sign*)

VAR
    x1,
    x2,
    y1,
    y2
       : integer;
    i: integer;
    
PROCEDURE vertausche (VAR a, b: integer);
   VAR hilf: integer;
   BEGIN
     hilf := a;
     a := b;
     b := hilf;
   END; (* vertauschen *)
   
PROCEDURE line ( x1, y1, x2, y2: integer );
   (* Zeichnet die Strecke von (x1;y1) nach (x2;y2) *)
   VAR
       x, y   : integer;   (* alte Koordinaten *)
       Dx, Dy : integer; (* Deltax, Deltay *)
       sx, sy,          (* sign(delta) *)
       e      : integer; 
       vertauscht: BOOLEAN;
       zaehler: integer;
   BEGIN
     x := x1;
     y := y1;
     Dx := abs (x2 - x1);
     Dy := abs (y2 - y1);
     sx := sign (x2 - x1);
     sy := sign (y2 - y1);
    IF Dy > Dx 
       THEN
         BEGIN
           vertausche (Dx, Dy);
           vertauscht := TRUE;
         END (* then *)
       ELSE
         vertauscht := FALSE;
    e := Dy + Dy - Dx;  (* Ende der Initialisierung *)
    
    (* Hauptschleife *)
    
    FOR zaehler := 1 TO Dx DO
        BEGIN
          put_pixel ( x,y,1 );
          WHILE e >= 0 DO
            BEGIN
              IF vertauscht
                 THEN
                   x := x + sx
                 ELSE
                   y := y + sy;
              e := e - Dx - Dx;
            END;  (* while *)
          IF vertauscht 
             THEN
               y := y + sy
             ELSE
               x := x + sx;
          e := e + Dy + Dy;
        END;  (* for *)
    END;  (* line *)
    
BEGIN                  (* Hauptprogramm *)
  clear_home;
(*
  writeln ('Bresenham - Demo');
  writeln;
  write ('Bitte die Koordinaten von Punkt 1 eingeben! x1 = ');
  readln (x1);
  write ('                                            y1 = ');
  readln (y1);
  write ('Bitte die Koordinaten von Punkt 2 eingeben! x2 = ');
  readln (x2);
  write ('                                            y2 = ');
  readln (y2);
  clear_home;
  line (x1, y1, x2, y2);
  readln; 
*)
  FOR i := 0 TO 640 DO
      line (i, 0, i, 400 );
END.                   
                          
                   
                         
                    
